function [u] = genbil(type,X,Y,noise)
%
% Type 1 deltafunktion i X/2, Y/2
% Type 2 Skr linie gennem midt og hldning 0.5
% Type 3 To Skr linier gennem midt og hldning 0.5 hhv. 0.25
% Type 4 To Deltafunktioner
% Type 5 To Skr linier gennem midt og hldning 0.5 hhv. 0.25 med stj
% Ellers en firkant centreret

if exist('noise')==0
  noise=0;
end;

u=zeros(X,Y);

if type==1
  u((X-1)/2+1-31,(Y-1)/2-30+1)=1.0;
  u((X-1)/2+1-21,(Y-1)/2-20+1)=0.85;
  u((X-1)/2+1-11,(Y-1)/2-10+1)=0.7;
  u((X-1)/2+1-1,(Y-1)/2+1)=0.55;
  u((X-1)/2+1+9,(Y-1)/2+10+1)=0.4;
  u((X-1)/2+1+19,(Y-1)/2+20+1)=0.25;
  u((X-1)/2+1+29,(Y-1)/2+30+1)=0.1;

  u((X-1)/2+1-30+10,(Y-1)/2-30+1)=1.0;
  u((X-1)/2+1-20+10,(Y-1)/2-20+1)=0.85;
  u((X-1)/2+1-10+10,(Y-1)/2-10+1)=0.7;
  u((X-1)/2+1+10,(Y-1)/2+1)=0.55;
  u((X-1)/2+1+10+10,(Y-1)/2+10+1)=0.4;
  u((X-1)/2+1+20+10,(Y-1)/2+20+1)=0.25;
  u((X-1)/2+1+30+10,(Y-1)/2+30+1)=0.1;
elseif type==2
  for i=1:X,
    u(i,round((i-50-1)/3+50+1))=1.0;
  end
elseif type==3
  for i=1:X,
    u(i,round((i-50-1)/3+50+1))=1.0;
  end
  for i=1:X,
    j=round((i-(X-1)/2-1)*0.25+(Y-1)/2+1+10);
    u(i,j)=1.0;
  end
elseif type==4
  u((X-1)/2+1,(Y-1)/2+1)=1.0;
  u((X-1)/2+3,(Y-1)/2+2)=1.0;
elseif type==5
  for i=1:X,
    u(i,round((i-X/2-1)*0.5+Y/2+1))=1.0;
  end
  for i=1:X,
    j=round((i-X/2-1)*0.25+Y/2+1+10);
    u(i,j)=1.0;
  end
  u=u+randn(X,Y)*noise;
elseif type==6
  Xh=(X-1)/2;
  rho=20.0;
  theta=pi/180*45;
  nu=1.5;
  if (sin(theta)>sqrt(0.5))
    p=-1/tan(theta);
    tau=rho/sin(theta);
    for i=1:X,
      j=round((i-Xh-1)*p+1+Xh+tau);
      if ((j>0) & (j<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  else
    r=-tan(theta);
    eta=rho/cos(theta);
    for j=1:X,
      i=round((j-Xh-1)*r+1+Xh+eta);
      if ((i>0) & (i<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  end
  disp(sprintf('rho=%f  theta=%f  nu=%f',rho,theta,nu));

  rho=0;
  theta=pi/180*80;
  nu=1;
  if (sin(theta)>sqrt(0.5))
    p=-1/tan(theta);
    tau=rho/sin(theta);
    for i=1:X,
      j=round((i-Xh-1)*p+1+Xh+tau);
      if ((j>0) & (j<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  else
    r=-tan(theta);
    eta=rho/cos(theta);
    for j=1:X,
      i=round((j-Xh-1)*r+1+Xh+eta);
      if ((i>0) & (i<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  end
  disp(sprintf('rho=%f  theta=%f  nu=%f',rho,theta,nu));

  rho=40;
  theta=pi/180*45;
  nu=-1;
  if (sin(theta)>sqrt(0.5))
    p=-1/tan(theta);
    tau=rho/sin(theta);
    for i=1:X,
      j=round((i-Xh-1)*p+1+Xh+tau);
      if ((j>0) & (j<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  else
    r=-tan(theta);
    eta=rho/cos(theta);
    for j=1:X,
      i=round((j-Xh-1)*r+1+Xh+eta);
      if ((i>0) & (i<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  end
  disp(sprintf('rho=%f  theta=%f  nu=%f',rho,theta,nu));

  rho=-20;
  theta=pi/180*50;
  nu=1.0;
  if (sin(theta)>sqrt(0.5))
    p=-1/tan(theta);
    tau=rho/sin(theta);
    for i=1:X,
      j=round((i-Xh-1)*p+1+Xh+tau);
      if ((j>0) & (j<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  else
    r=-tan(theta);
    eta=rho/cos(theta);
    for j=1:X,
      i=round((j-Xh-1)*r+1+Xh+eta);
      if ((i>0) & (i<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  end
  disp(sprintf('rho=%f  theta=%f  nu=%f',rho,theta,nu));

  rho=-40;
  theta=pi/180*170;
  nu=-1;
  if (sin(theta)>sqrt(0.5))
    p=-1/tan(theta);
    tau=rho/sin(theta);
    for i=1:X,
      j=round((i-Xh-1)*p+1+Xh+tau);
      if ((j>0) & (j<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  else
    r=-tan(theta);
    eta=rho/cos(theta);
    for j=1:X,
      i=round((j-Xh-1)*r+1+Xh+eta);
      if ((i>0) & (i<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  end
  disp(sprintf('rho=%f  theta=%f  nu=%f',rho,theta,nu));

  rho=30;
  theta=pi/180*100;
  nu=1;
  if (sin(theta)>sqrt(0.5))
    p=-1/tan(theta);
    tau=rho/sin(theta);
    for i=1:X,
      j=round((i-Xh-1)*p+1+Xh+tau);
      if ((j>0) & (j<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  else
    r=-tan(theta);
    eta=rho/cos(theta);
    for j=1:X,
      i=round((j-Xh-1)*r+1+Xh+eta);
      if ((i>0) & (i<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  end
  disp(sprintf('rho=%f  theta=%f  nu=%f',rho,theta,nu));

  rho=10;
  theta=pi/180*10;
  nu=1;
  if (sin(theta)>sqrt(0.5))
    p=-1/tan(theta);
    tau=rho/sin(theta);
    for i=1:X,
      j=round((i-Xh-1)*p+1+Xh+tau);
      if ((j>0) & (j<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  else
    r=-tan(theta);
    eta=rho/cos(theta);
    for j=1:X,
      i=round((j-Xh-1)*r+1+Xh+eta);
      if ((i>0) & (i<=X))
        u(i,j)=u(i,j)+nu;
      end
    end
  end
  disp(sprintf('rho=%f  theta=%f  nu=%f',rho,theta,nu));
elseif type==7
  for i=1:X,
    u(i,round((i-50-1)/9+50+1))=1.0;
  end
  for j=1:Y,
    i=round((j-(Y-1)/2-1)/9+50+1);
    u(i,j)=1.0;
  end
elseif type==8
  for i=1:X,
    j1=round((i-50-1)/3+50+1);
    j2=round((i-50-1)*(-0.25)+60+1);
    u(i,j1)=1.0;
    u(i,j2)=1.0;
  end
  uu=u;
  u=zeros(size(u));
  for i=1:X,
    for j=1:Y,
      uv=uu(i,j);
      if (uv>0)
        u(i,j-1)=u(i,j-1)-0.5*uv;
        u(i,j+1)=u(i,j+1)-0.5*uv;
        u(i,j)=u(i,j)+uv;
      end
    end
  end
elseif type==9
  for i=1:X,
    u(i,55+1)=1.0;
  end
  u(51,51)=1.0;
elseif type==10
  u=rand(101,101)*noise+noise;
  u(1,31)=1.0;
  u(11,31)=1.0;
  u(21,31)=1.0;
  u(51,31)=1.0;
  u(101,31)=1.0;
else
  for i=1:X
    for j=1:Y,
      if (i>=X/4) & (i<=3*X/4) &(j>=X/4) & (j<=3*X/4)
        u(i,j)=1.0;
      else
        u(i,j)=0.0;
      end
    end
   end
end



