clc;
clear;

M=101;
Delta_x=1.0;
x_min=-(M-1)*0.5*Delta_x;

Delta_rho=Delta_x;
R=2*M-1;
rho_min=-Delta_rho*(R-1)*0.5;

T=ceil(pi/(sqrt(2.0)*(M-1)*Delta_x/Delta_rho));
T=50;
Delta_theta=pi/T;

theta_min=0;

col=4;
noise=0.01;
u = genimage(10,M,M,noise);

% Fundamental setting.
setpar     = zeros(9,1);
setpar(1)  =      M;     
setpar(2)  =      x_min; 
setpar(3)  =      Delta_x;
setpar(4)  =      T;      
setpar(5)  =      Delta_theta;   
setpar(6)  =      R;       
setpar(7)  =      rho_min;
setpar(8)  =      Delta_rho;
setpar(9)  =      theta_min;
si(u,col,1,setpar(2),-setpar(2),setpar(2),-setpar(2),'x','y','');

% Use ORG RAD
opt(2)=1; %Number of runs only for test
disp('Using Hough');

opt(1)=1;
tic
v1 = Hough(u,setpar,opt);
t(1)=toc/opt(2);

opt(1)=2;
tic
v2 = Hough(u,setpar,opt);
t(2)=toc/opt(2);

opt(1)=3;
tic
v3 = Hough(u,setpar,opt);
t(3)=toc/opt(2);

opt(1)=4;
tic
v4 = Hough(u,setpar,opt);
t(4)=toc/opt(2);

format short e
disp(t); %Time usage

si(v1,col,1,0,pi-setpar(5),setpar(7),-setpar(7),'theta','rho','Hough opt 0');
si(v2,col,1,0,pi-setpar(5),setpar(7),-setpar(7),'theta','rho','Hough opt 1');
si(v3,col,1,0,pi-setpar(5),setpar(7),-setpar(7),'theta','rho','Hough opt 2');
si(v4,col,1,0,pi-setpar(5),setpar(7),-setpar(7),'theta','rho','Hough opt 3');





