clc;
clear;

M=101;
Delta_x=1.0;
x_min=-(M-1)*0.5*Delta_x;

T=ceil(pi*(M-1));
Delta_theta=pi/T;

Delta_rho=Delta_x/sqrt(2);
R=2*M-1;
rho_min=-Delta_rho*(R-1)*0.5;
theta_min=0;

col=4;

u = genimage(1,M,M);

% Fundamental setting.
setpar     = zeros(9,1);
setpar(1)  =      M;     
setpar(2)  =      x_min; 
setpar(3)  =      Delta_x;
setpar(4)  =      T;      
setpar(5)  =      Delta_theta;   
setpar(6)  =      R;       
setpar(7)  =      rho_min;
setpar(8)  =      Delta_rho;
setpar(9)  =      theta_min;
si(u,col,1,setpar(2),-setpar(2),setpar(2),-setpar(2),'x','y','');

% Use ORG RAD
disp('Using RT');
tic
v1 = oradNN(u,setpar);
toc
tic
v2 = oradLI(u,setpar);
toc
tic
v3 = oradSINC(u,setpar);
toc

maxmax(1)=max(max(v1));
maxmax(2)=max(max(v1));
maxmax(3)=max(max(v1));
mx=max(maxmax);

si(v1,col,1,0,pi-setpar(5),setpar(7),-setpar(7),'theta','rho','NN',0,0,mx);
si(v2,col,1,0,pi-setpar(5),setpar(7),-setpar(7),'theta','rho','LI',0,0,mx);
si(v3,col,1,0,pi-setpar(5),setpar(7),-setpar(7),'theta','rho','SINC',0,0,mx);








