function [u] = genimage(type,X,Y,noise)

if exist('noise')==0
  noise=0;
end;

u=zeros(X,Y);

if type==1
  u((X-1)/2+1,(Y-1)/2+1)=1.0;
elseif type==2
  for i=1:X,
    u(i,round((i-50-1)/3+50+1))=1.0;
  end
elseif type==3
  for i=1:X,
    u(i,round((i-50-1)/3+50+1))=1.0;
  end
  for i=1:X,
    j=round((i-(X-1)/2-1)*(-0.25)+50+1+10);
    u(i,j)=1.0;
  end
  for i=1:X,
    j=round((i-(X-1)/2-1)*(-0.20)+52+1+10);
    u(i,j)=1.0;
  end
elseif type==4
  u((X-1)/2+1,(Y-1)/2+1)=1.0;
  u((X-1)/2+3,(Y-1)/2+2)=1.0;
elseif type==5
  for i=1:X,
    u(i,round((i-X/2-1)*0.5+Y/2+1))=1.0;
  end
  for i=1:X,
    j=round((i-X/2-1)*0.25+Y/2+1+10);
    u(i,j)=1.0;
  end
  u=u+randn(X,Y)*noise;
elseif type==6
  for i=1:X,
    j=round((i-X/2-1)*0.10+1+60);
    u(i,j)=u(i,j)+1.5;
  end
  for i=1:X,
    j=round((i-X/2-1)*0.25+1+50);
    u(i,j)=u(i,j)-1.5;
  end
  for i=1:X,
    j=round((i-X/2-1)*(-0.10)+1+80);
    u(i,j)=u(i,j)-1.0;
  end
  for i=1:X,
    j=round((i-X/2-1)*(-0.25)+1+30);
    u(i,j)=u(i,j)+1.0;
  end
  for i=1:X,
    j=round((i-X/2-1)*0.0+1+30);
    u(i,j)=u(i,j)+1.0;     
  end                      
  for i=1:X,               
    j=round((i-X/2-1)*0.40+1+45);
    u(i,j)=u(i,j)-1.0;     
  end                      
  for i=1:X,               
    j=round((i-X/2-1)*(-0.36)+1+52);
    u(i,j)=u(i,j)-1.0;     
  end                      
  for i=1:X,               
    j=round((i-X/2-1)*0.1+1+80);
    u(i,j)=u(i,j)+0.5;
  end
  u=u+randn(X,Y)*noise;
elseif type==7
  for i=1:X,
    u(i,round((i-50-1)/9+50+1))=1.0;
  end
  for j=1:Y,
    i=round((j-(Y-1)/2-1)/9+50+1);
    u(i,j)=1.0;
  end
elseif type==8
  for i=1:X,
    j1=round((i-50-1)/3+50+1);
    j2=round((i-50-1)*(-0.25)+60+1);
    u(i,j1)=1.0;
    u(i,j2)=1.0;
  end
  uu=u;
  u=zeros(size(u));
  for i=1:X,
    for j=1:Y,
      uv=uu(i,j);
      if (uv>0)
        u(i,j-1)=u(i,j-1)-0.5*uv;
        u(i,j+1)=u(i,j+1)-0.5*uv;
        u(i,j)=u(i,j)+uv;
      end
    end
  end
elseif type==9
   for i=1:X,
    u(i,round((i-50-1)/3+50+1))=1.0*(X-i)/X;
  end
  for i=1:X,
    j=round((i-(X-1)/2-1)*0.25+50+1+10);
    u(i,j)=1.0*(X-i)/X;
  end
elseif type==10
   for i=10:80,
    u(i,round((i-50-1)/(-3)+50+1))=1.0;
   end
  for i=40:X,
    j=round((i-50-1)*(-0.1)+50+1+20);
    u(i,j)=1.0;
  end
  for i=1:60,
    j=round((i-50-1)*0.25+50+1+10);
    u(i,j)=1.0;
  end
  for i=40:80,
    j=round((i-50-1)*(-0.25)+30+1+10);
    u(i,j)=1.0;
  end
  for i=1:60,
    j=round((i-50-1)*0.5+50+1);
    u(i,j)=1.0;
  end
  for i=10:60,
    j=round((i-50-1)*0.0+20+1);
    u(i,j)=1.0;
  end
elseif type==11
  u(1,51)=1.0;
  u(10,51)=1.0;
  u(51,51)=1.0;
  u(55,51)=1.0;
  u(101,51)=1.0;
elseif type==12
  randn('seed',sum(100*clock));
  if noise<0
    noise=-noise;
    disp('Using Gaussian Noise');
    for i=1:X,
      u(i,round((i-50-1)*0.3+51+noise*randn))=1.0;
    end
  else
    disp('Using uniform Noise');
    for i=1:X,
      u(i,round((i-50-1)*0.3+51+noise*(rand-0.5)*sqrt(12)))=1.0;
    end
  end
else
  for i=1:X
    for j=1:Y,
      if (i>=X/4) & (i<=3*X/4) &(j>=X/4) & (j<=3*X/4)
        u(i,j)=1.0;
      else
        u(i,j)=0.0;
      end
    end
   end
end