clc;
clear;

imtype=3;

Slant_NN=0;
Slant_NNopt=1;
Slant_LI=0;
Slant_SINC=0;
Hough_NN=0;
Hough_NNopt=1;
Hough_LIopt=0;

disp(sprintf('Slant_NN    = %i',Slant_NN));
disp(sprintf('Slant_NNopt = %i',Slant_NNopt));
disp(sprintf('Slant_LI    = %i',Slant_LI));
disp(sprintf('Slant_SINC  = %i',Slant_SINC));
disp(sprintf('HoughNN     = %i',Hough_NN));
disp(sprintf('HoughNNopt  = %i',Hough_NNopt));
disp(sprintf('HoughLIopt  = %i',Hough_LIopt));

noise=-0.25;

XSamples=101;
xlow=-(XSamples-1)*0.5;
DeltaX=1.0;

YSamples=101;
ylow=0.0000;
DeltaY=1.0;

TauSamples=101;
taulow=0.0000;
DeltaTau=1;

PSamples=101;
DeltaP=0.02;
plow=-(PSamples-1)*0.5*DeltaP;

col=4;

% Fundamental setting.
setpar     = zeros(12,1);
setpar(1)  = XSamples;    
setpar(2)  = xlow;   
setpar(3)  = DeltaX; 
setpar(4)  = YSamples;    
setpar(5)  = ylow;  
setpar(6)  = DeltaY;
setpar(7)  = TauSamples;
setpar(8)  = taulow;
setpar(9)  = DeltaTau;
setpar(10) = PSamples;
setpar(11) = plow;
setpar(12) = DeltaP;

u = genimage(imtype,XSamples,YSamples,noise);
u=u+rand(size(u));
si(u,col,1,xlow,xlow+XSamples*DeltaX,ylow,ylow+YSamples*DeltaY,'x','y','');

if Slant_NN==1
  disp('Using NN approximation');
  tic
  v_slantNN = radonNN(u,setpar);
  timeSlant_NN=toc;
  disp(sprintf('time SlantNN %f sec',timeSlant_NN));
  si(v_slantNN,col,1,plow,plow+PSamples*DeltaP,taulow,...
      taulow+TauSamples*DeltaTau,'p','tau','Radon NN',0,0,101);
  maxSlantNN=max(max(v_slantNN))
  [I,J]=find(v_slantNN==maxSlantNN);
  disp(sprintf('\nmax at p=%f and k=%f\n',plow+(I-1)*DeltaP,taulow+(J-1)*DeltaTau));
end

if Slant_NNopt==1
  disp('Using NN opt approximation');
  tic
  v_slantNNopt = radonNNopt(u,setpar);
  timeSlant_NNopt=toc;
  disp(sprintf('time SlantNNopt %f sec',timeSlant_NNopt));
  si(v_slantNNopt,col,1,plow,plow+PSamples*DeltaP,taulow,...
      taulow+TauSamples*DeltaTau,'p','tau','Radon NN',0,0,101);
  si(v_slantNNopt,col,1,plow,plow+PSamples*DeltaP,taulow,...
      taulow+TauSamples*DeltaTau,'p','tau','Radon NN');
  maxSlantNNopt=max(max(v_slantNNopt))
  [I,J]=find(v_slantNNopt==maxSlantNNopt);
  disp(sprintf('\nmax at p=%f and k=%f\n',plow+(I-1)*DeltaP,taulow+(J-1)*DeltaTau));
end

if Slant_LI==1,
  disp('Using LI approximation');
  tic
  v_slantLI = radonLI(u,setpar);
  timeSlant_LI=toc;
  disp(sprintf('time SlantLI %f sec',timeSlant_LI));

  si(v_slantLI,col,1,plow,plow+PSamples*DeltaP,taulow,...
      taulow+TauSamples*DeltaTau,'p','tau','Radon LI',0,0,101);
  maxSlantLI=max(max(v_slantLI))
  [I,J]=find(v_slantLI==maxSlantLI);
  disp(sprintf('\nmax at p=%f and k=%f\n',plow+(I-1)*DeltaP,taulow+(J-1)*DeltaTau));
end

if Slant_SINC==1 
  disp('Using SINC approximation');
  tic
  v_slantSINC = radonSINC(u,setpar);
  timeSlant_SINC=toc;
  disp(sprintf('time SlantSINC %f sec',timeSlant_SINC));

  si(v_slantSINC,col,1,plow,plow+PSamples*DeltaP,taulow,... 
      taulow+TauSamples*DeltaTau,'p','tau','Radon Sinc',0,0,101);
  maxSlantSINC=max(max(v_slantSINC))
  [I,J]=find(v_slantSINC==maxSlantSINC);
  disp(sprintf('\nmax at p=%f and k=%f\n',plow+(I-1)*DeltaP,taulow+(J-1)*DeltaTau));
end

if Hough_NN==1 
  disp('Using Hough NN approximation');
  tic
  v_houghNN = houghNN(u,setpar);
  timeHough_NN=toc;
  disp(sprintf('time HoughNN %f sec',timeHough_NN));

  si(v_houghNN,col,1,plow,plow+PSamples*DeltaP,taulow,... 
      taulow+TauSamples*DeltaTau,'p','tau','Hough NN',0,0,101);
  maxhoughNN=max(max(v_houghNN))
  [I,J]=find(v_slanthoughNN==maxHoughNN);
  disp(sprintf('\nmax at p=%f and k=%f\n',plow+(I-1)*DeltaP,taulow+(J-1)*DeltaTau));
end

if Hough_NNopt==1 
  disp('Using Hough NN opt approximation');
  tic
  v_houghNNopt = houghNNopt(u,setpar);
  timeHough_NNopt=toc;
  disp(sprintf('time HoughNNopt %f sec',timeHough_NNopt));
  si(v_houghNNopt,col,1,plow,plow+PSamples*DeltaP,taulow,... 
      taulow+TauSamples*DeltaTau,'p','tau','Hough NN',0,0,101);
  maxhoughNNopt=max(max(v_houghNNopt))
  [I,J]=find(v_houghNNopt==maxhoughNNopt);
  disp(sprintf('\nmax at p=%f and k=%f\n',plow+(I-1)*DeltaP,taulow+(J-1)*DeltaTau));
end

if Hough_LIopt==1 
  disp('Using Hough LI opt approximation');
  tic
  v_houghLIopt = houghLIopt(u,setpar);
  timeHough_LIopt=toc;
  disp(sprintf('time HoughLIopt %f sec',timeHough_LIopt));
  si(v_houghLIopt,col,1,plow,plow+PSamples*DeltaP,taulow,... 
      taulow+TauSamples*DeltaTau,'p','tau','Hough LI',0,0,101);
  maxhoughLIopt=max(max(v_houghLIopt))
  [I,J]=find(v_slanthoughLIopt==maxHoughLIopt);
  disp(sprintf('\nmax at p=%f and k=%f\n',plow+(I-1)*DeltaP,taulow+(J-1)*DeltaTau));
end




